                     MEMBER('URLMGR.clw')         ! This is a MEMBER module
M__URLMGR PROCEDURE

LocalRequest         LONG,AUTO
OriginalRequest      LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG
WindowInitialized    LONG
ForceRefresh         LONG,AUTO
CurrentSelected  LONG,AUTO
AppFrame             APPLICATION('URL Manager'),AT(0,0,318,190),HVSCROLL,ICON('CANADA.ICO'),STATUS(-1,80,120,45),SYSTEM,MAX,RESIZE,IMM
                       MENUBAR
                         MENU('&File'),USE(?FileMenu)
                           ITEM('&Print Setup ...'),USE(?PrintSetup),MSG('Setup printer'),STD(STD:PrintSetup)
                           ITEM,SEPARATOR
                           MENU('&Import'),USE(?Import),MSG('Import URL Locations from Text Files, HTML documents, etc.'),KEY(MouseCenter)
                             ITEM('from &ASCII (Comma Delimited) file'),USE(?ImportASCII),MSG('Import from ASCII List - i.e. "http://www.here.com","The Here and Now",etc.'),KEY(CtrlA)
                             ITEM('from &HTML Document (Ctrl+H)'),USE(?ImportHTML),MSG('Get all addresses within an HTML document'),KEY(CtrlH)
                             ITEM('from &Other text files'),USE(?ImportOther)
                           END
                           ITEM('&Export'),USE(?Export),MSG('Export to HTML document'),KEY(CtrlE)
                           ITEM('Item&21'),USE(?Item21),SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Browse'),USE(?BrowseMenu),MSG('Browse data'),KEY(MouseRight)
                           ITEM('Browse by URL &Location (Ctrl+L)'),USE(?BrowseURLByLocationItem),MSG('Browse URL MGR database by Location'),KEY(CtrlL)
                           ITEM('Browse by &Category (Ctrl+C)'),USE(?BrowseURLByCategoryItem),MSG('Browse URLMGR database by Category'),KEY(CtrlC)
                           ITEM('Browse by &Rating'),USE(?BrowseURLByRatingItem),MSG('Browse URL MGR database by Rating'),KEY(CtrlR)
                           ITEM('Browse by &Keyword'),USE(?BrowseURLByKeywordItem),MSG('Browse URL MGR database by Keyword'),KEY(CTRLK)
                           ITEM('Item&24'),USE(?Item24),SEPARATOR
                           ITEM('&Setup Categories'),USE(?BrowseCategories),KEY(CtrlS)
                         END
                         MENU('&Report'),USE(?ReportMenu),MSG('Print a report')
                           ITEM('Report by &Location'),USE(?ReportURLByLocationItem),MSG('Report URLMGR by Location')
                           ITEM('Report by &Category'),USE(?ReportURLByCategoryItem),MSG('Report URLMGR by Category')
                           ITEM('Report by &Rating'),USE(?ReportURLByRatingItem),MSG('Report URLMGR by Rating')
                           ITEM('Report by &Keyword'),USE(?ReportURLByKeywordItem),MSG('Report URLMGR by Keyword')
                         END
                         MENU('&Window'),MSG('Create and Arrange windows')
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),MSG('Windows Help')
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                           ITEM('Item&28'),USE(?Item28),SEPARATOR
                           ITEM('&About'),USE(?About),MSG('About This Program'),KEY(CtrlX)
                         END
                       END
                     END
  CODE
    ORIGPATH=PATH()
  LocalRequest = GlobalRequest
  OriginalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  IF Categories::Used = 0
    CheckOpen(Categories,1)
  END
  Categories::Used += 1
  IF URLMGR::Used = 0
    CheckOpen(URLMGR,1)
  END
  URLMGR::Used += 1
  OPEN(AppFrame)
  WindowOpened=True
  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      END
    OF EVENT:GainFocus
      IF NOT WindowInitialized
        WindowInitialized = True
        DO InitializeWindow
      ELSE
        ForceRefresh = True
        DO RefreshWindow
      END
    END
    CASE FIELD()
    OF ?PrintSetup
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?ImportASCII
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        ImportASCII 
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?ImportHTML
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        ImportHTML 
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?ImportOther
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        ImportOther 
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?Export
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        Export 
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?Exit
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?Cut
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?Copy
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?Paste
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?BrowseURLByLocationItem
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF START(BrowseURLByLocation,025000).
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?BrowseURLByCategoryItem
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF START(BrowseURLByCategory,025000).
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?BrowseURLByRatingItem
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF START(BrowseURLByRating,025000).
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?BrowseURLByKeywordItem
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF START(BrowseURLByKeyword,025000).
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?BrowseCategories
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        BrowseCATByCategory 
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?ReportURLByLocationItem
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF START(ReportURLByLocation,025000).
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?ReportURLByCategoryItem
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF START(ReportURLByCategory,025000).
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?ReportURLByRatingItem
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF START(ReportURLByRating,025000).
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?ReportURLByKeywordItem
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF START(ReportURLByKeyword,025000).
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    OF ?Tile
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?Cascade
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?Arrange
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?Helpindex
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?HelpSearch
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?HelpOnHelp
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
      END
    OF ?About
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        About 
        LocalRequest = OriginalRequest
        DO RefreshWindow
      END
    END
  END
  DO ProcedureReturn
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
  Categories::Used -= 1
  IF Categories::Used = 0 THEN CLOSE(Categories).
  URLMGR::Used -= 1
  IF URLMGR::Used = 0 THEN CLOSE(URLMGR).
  IF WindowOpened
    CLOSE(AppFrame)
  END
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!---------------------------------------------------------------------------
InitializeWindow ROUTINE
  DO RefreshWindow
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
  CurrentSelected = SELECTED()
  DISPLAY()
  ForceRefresh = False
  IF SELECTED() <> CurrentSelected
    SELECT(CurrentSelected)
  END
!---------------------------------------------------------------------------
SyncWindow ROUTINE
!---------------------------------------------------------------------------
