                     MEMBER('URLMGR.clw')         ! This is a MEMBER module
Update_URL PROCEDURE

LocalRequest         LONG,AUTO
OriginalRequest      LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG
WindowInitialized    LONG
ForceRefresh         LONG,AUTO
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
CurrentSelected  LONG,AUTO
SAV::URL:Record      STRING(SIZE(URL:Record))
SAV::URL:SiteInfo    STRING(SIZE(URL:SiteInfo))
FormWindow           WINDOW('Edit URL Location'),AT(,,250,144),CENTER,SYSTEM,GRAY,MDI
                       PROMPT('&Location:'),AT(24,6,,),USE(?URL:Location:Prompt)
                       ENTRY(@S60),AT(83,6,,),USE(URL:Location)
                       PROMPT('&Description:'),AT(24,22,,),USE(?URL:Description:Prompt)
                       ENTRY(@S60),AT(83,22,,),USE(URL:Description)
                       PROMPT('&Category:'),AT(24,38,,),USE(?URL:Category:Prompt)
                       ENTRY(@S15),AT(83,38,,),USE(URL:Category)
                       BUTTON('&Select...'),AT(155,40,40,10),USE(?LookupCategory)
                       PROMPT('&Rating:'),AT(24,54,,),USE(?URL:Rating:Prompt)
                       ENTRY(@N2),AT(83,54,,),USE(URL:Rating)
                       PROMPT('&Keyword:'),AT(24,70,,),USE(?URL:Keyword:Prompt)
                       ENTRY(@s10),AT(83,70,,),USE(URL:Keyword)
                       PROMPT('Site &Info:'),AT(24,90,,),USE(?SiteInfo)
                       TEXT,AT(84,90,140,30),USE(URL:SiteInfo),MSG('Information about site')
                       BUTTON('&OK'),AT(160,125,40,12),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(205,125,40,12),USE(?Cancel)
                       STRING(@s40),AT(5,130,,),USE(ActionMessage),CENTER
                     END
  CODE
  LocalRequest = GlobalRequest
  OriginalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  IF URLMGR::Used = 0
    CheckOpen(URLMGR,1)
  END
  URLMGR::Used += 1
  SAV::URL:Record = URL:Record
  SAV::URL:SiteInfo = URL:SiteInfo
  IF LocalRequest = InsertRecord
    DO PrimeFields
  END
    IF LocalRequest = DeleteRecord
      LOOP
        LocalResponse = RequestCancelled
        SETCURSOR(Cursor:Wait)
        IF RIDelete:URLMGR()
          SETCURSOR()
          CASE StandardWarning(Warn:DeleteError)
          OF Button:Yes
            CYCLE
          OF Button:No OROF Button:Cancel
            BREAK
          END
        ELSE
          SETCURSOR()
          LocalResponse = RequestCompleted
        END
        BREAK
      END
      DO ProcedureReturn
    END
  OPEN(FormWindow)
  WindowOpened=True
  CASE LocalRequest
  OF InsertRecord
    ActionMessage = 'Record will be Added'
  OF ChangeRecord
    ActionMessage = 'Record will be Changed'
  OF DeleteRecord
  END
  ACCEPT
    CASE EVENT()
    OF EVENT:CloseWindow
      IF LocalResponse <> RequestCompleted
        RecordChanged = False
        IF LocalRequest = InsertRecord OR LocalRequest = ChangeRecord
          IF SAV::URL:Record <> URL:Record |
          OR SAV::URL:SiteInfo <> URL:SiteInfo
            RecordChanged = True
          END
        END
        IF RecordChanged
          CASE StandardWarning(Warn:SaveOnCancel)
          OF Button:Yes
            POST(Event:Accepted,?OK)
            CYCLE
          OF Button:No
          OF BUTTON:Cancel
            SELECT(?URL:Location:Prompt)
            CYCLE
          END
        END
      END
    OF EVENT:CloseDown
      IF LocalResponse <> RequestCompleted
        RecordChanged = False
        IF LocalRequest = InsertRecord OR LocalRequest = ChangeRecord
          IF SAV::URL:Record <> URL:Record |
          OR SAV::URL:SiteInfo <> URL:SiteInfo
            RecordChanged = True
          END
        END
        IF RecordChanged
          CASE StandardWarning(Warn:SaveOnCancel)
          OF Button:Yes
            POST(Event:Accepted,?OK)
            CYCLE
          OF Button:No
          OF BUTTON:Cancel
            SELECT(?URL:Location:Prompt)
            CYCLE
          END
        END
      END
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      END
      SELECT(?URL:Location:Prompt)
    OF EVENT:GainFocus
      IF NOT WindowInitialized
        WindowInitialized = True
        DO InitializeWindow
      ELSE
        ForceRefresh = True
        DO RefreshWindow
      END
    ELSE
      IF EVENT() = Event:Completed
        CASE LocalRequest
        OF InsertRecord
          ADD(URLMGR)
          CASE ERRORCODE()
          OF NoError
            LocalResponse = RequestCompleted
            POST(Event:CloseWindow)
          OF DupKeyErr
            IF DUPLICATE(URL:K_Location)
              IF StandardWarning(Warn:DuplicateKey,'URL:K_Location')
                SELECT(?URL:Location:Prompt)
                CYCLE
              END
            END
          ELSE
            IF StandardWarning(Warn:InsertError)
              SELECT(?URL:Location:Prompt)
              CYCLE
            END
          END
        OF ChangeRecord
          LOOP
            LocalResponse = RequestCancelled
            SETCURSOR(Cursor:Wait)
            IF RIUpdate:URLMGR(SAV::URL:Record,SAV::URL:SiteInfo)
              SETCURSOR()
              CASE StandardWarning(Warn:UpdateError)
              OF Button:Yes
                CYCLE
              OF Button:No
                POST(Event:CloseWindow)
                BREAK
              OF Button:Cancel
                SELECT(?URL:Location:Prompt)
                BREAK
              END
            ELSE
              SETCURSOR()
              LocalResponse = RequestCompleted
              POST(Event:CloseWindow)
            END
            BREAK
          END
        END
      END
    END
    CASE FIELD()
    OF ?LookupCategory
      CASE EVENT()
      OF EVENT:Accepted
         OMIT('->')
        !----------------------------------------
        | CallProcedureAsLookup
        | Lookup Procedure    SelectCategory
        | Before Lookup:      Cat:Category=URL:Category
        | After Complete:     URL:Category=Cat:Category
        | After Cancel:       
        !--------------------------------------->
        Cat:Category=URL:Category                         ! Source before Lookup
        GlobalRequest = SelectRecord                      ! Set Action for Lookup
        SelectCategory                                    ! Call the Lookup Procedure
        LocalResponse = GlobalResponse                    ! Save Action for evaluation
        GlobalResponse = RequestCancelled                 ! Clear Action
        IF LocalResponse = RequestCompleted               ! IF Lookup completed
          URL:Category=Cat:Category                       ! Source on Completion
        END                                               ! END (IF Lookup completed)
            DO RefreshWindow
        DO SyncWindow
      END
    OF ?OK
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF OriginalRequest = ChangeRecord OR OriginalRequest = InsertRecord
          SELECT()
        ELSE
          POST(EVENT:Completed)
        END
      END
    OF ?Cancel
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
  DO ProcedureReturn
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
  URLMGR::Used -= 1
  IF URLMGR::Used = 0 THEN CLOSE(URLMGR).
  IF WindowOpened
    CLOSE(FormWindow)
  END
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!---------------------------------------------------------------------------
InitializeWindow ROUTINE
  DO RefreshWindow
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
  CurrentSelected = SELECTED()
  DISPLAY()
  ForceRefresh = False
  IF SELECTED() <> CurrentSelected
    SELECT(CurrentSelected)
  END
!---------------------------------------------------------------------------
SyncWindow ROUTINE
!---------------------------------------------------------------------------
PrimeFields ROUTINE
  URL:Record = SAV::URL:Record
  URL:SiteInfo = SAV::URL:SiteInfo
  SAV::URL:Record = URL:Record
  SAV::URL:SiteInfo = URL:SiteInfo
