                     MEMBER('URLMGR.clw')         ! This is a MEMBER module
BrowseURLByKeyword PROCEDURE

LocalRequest         LONG,AUTO
OriginalRequest      LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG
WindowInitialized    LONG
ForceRefresh         LONG,AUTO
RecordFiltered       LONG
CurrentSelected  LONG,AUTO
Queue:Browse         QUEUE                        ! Browsing Queue
BRW1::URL:Keyword      LIKE(URL:Keyword)          ! Queue Display field
BRW1::URL:Location     LIKE(URL:Location)         ! Queue Display field
BRW1::URL:Description  LIKE(URL:Description)      ! Queue Display field
BRW1::URL:Category     LIKE(URL:Category)         ! Queue Display field
BRW1::URL:Rating       LIKE(URL:Rating)           ! Queue Display field
BRW1::Position         STRING(255)                ! Queue POSITION information
BRW1::Mark             BYTE                       ! Queue POSITION information
                     END                          ! END (Browsing Queue)
BRW1::QuickScan      BYTE                         ! Flag for Range/Filter test
BRW1::RecordStatus   BYTE                         ! Flag for Range/Filter test
BRW1::InitializePage BYTE                         ! Flag for Range/Filter test
BRW1::ItemsToFill    LONG                         ! Controls records retrieved
BRW1::MaxItemsInList LONG                         ! Retrieved after window opened
BRW1::LocatedPosition STRING(255)                 ! POSITION of located record
BRW1::QueuePointer   LONG                         ! Queue position of located record
BRW1::NextChoice     LONG                         ! Queue position of located record
BRW1::NewSelectPosted BYTE                        ! Queue position of located record
BRW1::CurrentScroll  BYTE                         ! Queue position of scroll thumb
BRW1::CurrentScrollRecord LONG                    ! Queue position of scroll thumb
BrowseWindow         WINDOW('Browse URLMGR Records By Keyword'),AT(,,247,129),SYSTEM,GRAY,MDI
                       LIST,AT(5,5,235,100),MSG('Browsing URLMGR Records In Keyword Order'),USE(?List),IMM,HVSCROLL,FORMAT('80L~Keyword~@s10@80L~Location~@S60@80L~Description~@S60@80L~Category~@S15@80L~Ra' &|
   'ting~@N2@'),FROM(Queue:Browse)
                       BUTTON('&Insert'),AT(5,110,45,12),USE(?Insert)
                       BUTTON('&Change'),AT(50,110,45,12),USE(?Change),DEFAULT
                       BUTTON('&Delete'),AT(95,110,45,12),USE(?Delete)
                       BUTTON('&Select'),AT(145,110,40,12),USE(?Select)
                       BUTTON('Close'),AT(200,110,40,12),USE(?Close)
                     END
  CODE
  LocalRequest = GlobalRequest
  OriginalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  IF URLMGR::Used = 0
    CheckOpen(URLMGR,1)
  END
  URLMGR::Used += 1
  OPEN(BrowseWindow)
  WindowOpened=True
  SET(URL:K_Keyword)
  ?List{Prop:Alrt,251} = MouseLeft2
  IF LocalRequest = SelectRecord
    ENABLE(?Select)
    ?Select{Prop:Default} = True
  ELSE
    DISABLE(?Select)
  END
  ?List{Prop:Alrt,255} = InsertKey
  ?List{Prop:Alrt,254} = DeleteKey
  ?List{Prop:Alrt,253} = CtrlEnter
  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      END
      SELECT(?List)
    OF EVENT:GainFocus
      IF NOT WindowInitialized
        WindowInitialized = True
        DO InitializeWindow
      ELSE
        ForceRefresh = True
        DO RefreshWindow
      END
    END
    CASE FIELD()
    OF ?List
      CASE EVENT()
      OF EVENT:NewSelection
        DO BRW1::NewSelection
      OF EVENT:ScrollUp
        DO BRW1::ScrollUp
      OF EVENT:ScrollDown
        DO BRW1::ScrollDown
      OF EVENT:PageUp
        DO BRW1::PageUp
      OF EVENT:PageDown
        DO BRW1::PageDown
      OF EVENT:ScrollTop
        DO BRW1::ScrollTop
      OF EVENT:ScrollBottom
        DO BRW1::ScrollBottom
      OF EVENT:AlertKey
        DO BRW1::AlertKey
      OF EVENT:ScrollDrag
        IF ?List{Prop:VScrollPos} <= 1
          POST(Event:ScrollTop,?List)
        ELSIF ?List{Prop:VScrollPos} = 100
          POST(Event:ScrollBottom,?List)
        ELSE
          URL:Keyword = Sort:Alpha:Array[?List{Prop:VScrollPos}]
          DO BRW1::LocateRecord
        END
      END
    OF ?Insert
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO BRW1::ButtonInsert
      END
    OF ?Change
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO BRW1::ButtonChange
      END
    OF ?Delete
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO BRW1::ButtonDelete
      END
    OF ?Select
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        LocalResponse = RequestCompleted
        POST(Event:CloseWindow)
      END
    OF ?Close
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
  DO ProcedureReturn
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
  URLMGR::Used -= 1
  IF URLMGR::Used = 0 THEN CLOSE(URLMGR).
  IF WindowOpened
    CLOSE(BrowseWindow)
  END
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!---------------------------------------------------------------------------
InitializeWindow ROUTINE
  DO BRW1::OpenWindow
  DO RefreshWindow
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
  CurrentSelected = SELECTED()
  IF NOT ForceRefresh
    IF RECORDS(Queue:Browse)
      GET(Queue:Browse,CHOICE(?List))
      DO BRW1::FillBuffer
      DO BRW1::ValidateRecord
      IF BRW1::RecordStatus <> Record:OK
        FREE(Queue:Browse)
        DO BRW1::InitializeBrowse
      END
    ELSE
      DO BRW1::InitializeBrowse
    END
  ELSE
    DO BRW1::InitializeBrowse
    DO BRW1::RefreshPage
  END
  ?List{Prop:VScrollPos} = BRW1::CurrentScroll
  DISPLAY()
  ForceRefresh = False
  IF SELECTED() <> CurrentSelected
    SELECT(CurrentSelected)
  END
!---------------------------------------------------------------------------
SyncWindow ROUTINE
  IF RECORDS(Queue:Browse)
    GET(Queue:Browse,CHOICE(?List))
    REGET(URL:K_Keyword,BRW1::Position)
  END
!---------------------------------------------------------------------------
!----------------------------------------------------------------------
BRW1::OpenWindow ROUTINE
  IF LocalRequest = SelectRecord
    SET(URL:K_Keyword,URL:K_Keyword)
    DO BRW1::LocateRecord
  ELSE
    DO BRW1::InitializeBrowse
    SELECT(?List,1)
  END
  DO BRW1::FillBuffer
  IF NOT BRW1::NewSelectPosted
    BRW1::NewSelectPosted = True
    POST(Event:NewSelection,?List)
  END
!----------------------------------------------------------------------
BRW1::InitializeBrowse ROUTINE
  IF SEND(URLMGR,'QUICKSCAN=on').
  IF SEND(URLMGR,'QUICKSCAN=off').
  DO BRW1::RefreshPage
!----------------------------------------------------------------------
BRW1::FillBuffer ROUTINE
  URL:Keyword = BRW1::URL:Keyword
  URL:Location = BRW1::URL:Location
  URL:Description = BRW1::URL:Description
  URL:Category = BRW1::URL:Category
  URL:Rating = BRW1::URL:Rating
!----------------------------------------------------------------------
BRW1::ResetLow ROUTINE
  SET(URL:K_Keyword)
!----------------------------------------------------------------------
BRW1::ResetHigh ROUTINE
  SET(URL:K_Keyword)
!----------------------------------------------------------------------
BRW1::ResetClear ROUTINE
  SET(URL:K_Keyword)
!----------------------------------------------------------------------
BRW1::FillQueue ROUTINE
  BRW1::URL:Keyword = URL:Keyword
  BRW1::URL:Location = URL:Location
  BRW1::URL:Description = URL:Description
  BRW1::URL:Category = URL:Category
  BRW1::URL:Rating = URL:Rating
  BRW1::Position = POSITION(URL:K_Keyword)
!----------------------------------------------------------------------
BRW1::NewSelection ROUTINE
  BRW1::NewSelectPosted = False
  IF RECORDS(Queue:Browse)
    DO BRW1::FillBuffer
    BRW1::CurrentScroll = 100
    LOOP BRW1::CurrentScrollRecord = 1 TO 100
      IF Sort:Alpha:Array[BRW1::CurrentScrollRecord] => UPPER(URL:Keyword)
        IF BRW1::CurrentScrollRecord <= 1
          BRW1::CurrentScroll = 0
        ELSIF BRW1::CurrentScrollRecord = 100
          BRW1::CurrentScroll = 100
        ELSE
          BRW1::CurrentScroll = ((BRW1::CurrentScrollRecord / 100) * 100)
        END
        BREAK
      END
    END
    DO RefreshWindow
  END
!----------------------------------------------------------------------
BRW1::ScrollUp ROUTINE
  IF RECORDS(Queue:Browse)
    IF CHOICE(?List)>1
      SELECT(?List, CHOICE(?List)-1)
    ELSE
      GET(Queue:Browse,1)                         ! Get the first queue item
      RESET(URL:K_Keyword,BRW1::Position)         ! Reset for sequential processing
      NOMEMO(URLMGR)
      PREVIOUS(URLMGR)                            ! Retrieve record, reverse access
      BRW1::ItemsToFill = 1                       ! Load a single item
      DO BRW1::FillBackward                       ! Fill with previous read(s)
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::ScrollDown ROUTINE
  IF RECORDS(Queue:Browse)
    IF CHOICE(?List)<RECORDS(Queue:Browse)
      SELECT(?List, CHOICE(?List)+1)
    ELSE
      GET(Queue:Browse,RECORDS(Queue:Browse))     ! Get the last queue item
      RESET(URL:K_Keyword,BRW1::Position)         ! Reset for sequential processing
      NOMEMO(URLMGR)
      NEXT(URLMGR)                                ! Retrieve record, forward access
      BRW1::ItemsToFill = 1                       ! load a single item
      DO BRW1::FillForward                        ! Fill with next read(s)
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::PageUp ROUTINE
  IF RECORDS(Queue:Browse)
    GET(Queue:Browse,1)                           ! Get the first queue item
    RESET(URL:K_Keyword,BRW1::Position)           ! Reset for sequential processing
    NOMEMO(URLMGR)
    PREVIOUS(URLMGR)                              ! Retrieve record, reverse access
    BRW1::ItemsToFill = ?List{Prop:Items}         ! Load a full page
    DO BRW1::FillBackward                         ! Fill with previous read(s)
    IF BRW1::ItemsToFill
      BRW1::NextChoice = CHOICE(?List)-BRW1::ItemsToFill
      IF BRW1::NextChoice < 1
        BRW1::NextChoice = 1
      END
      SELECT(?List, BRW1::NextChoice)
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::PageDown ROUTINE
  IF RECORDS(Queue:Browse)
    GET(Queue:Browse,RECORDS(Queue:Browse))       ! Get the last queue item
    RESET(URL:K_Keyword,BRW1::Position)           ! Reset for sequential processing
    NOMEMO(URLMGR)
    NEXT(URLMGR)                                  ! Retrieve record, forward access
    BRW1::ItemsToFill = ?List{Prop:Items}         ! Load a full page
    DO BRW1::FillForward                          ! Fill with next read(s)
    IF BRW1::ItemsToFill
      BRW1::NextChoice = CHOICE(?List)+BRW1::ItemsToFill
      IF BRW1::NextChoice > RECORDS(Queue:Browse)
        BRW1::NextChoice = RECORDS(Queue:Browse)
      END
      SELECT(?List, BRW1::NextChoice)
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::ScrollTop ROUTINE
  IF RECORDS(Queue:Browse)
    FREE(Queue:Browse)
    DO BRW1::RefreshPage
    SELECT(?List,1)                               ! Select first list item
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::ScrollBottom ROUTINE
  IF RECORDS(Queue:Browse)
    SETCURSOR(Cursor:Wait)
    FREE(Queue:Browse)                            ! Free the browse queue
    DO BRW1::ResetHigh                            ! Reset for first page access
    BRW1::ItemsToFill = ?List{Prop:Items}         ! Load a full page
    DO BRW1::FillBackward                         ! Fill with previous read(s)
    SELECT(?List, RECORDS(Queue:Browse))          ! Select last list item
    SETCURSOR()
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::AlertKey ROUTINE
  IF RECORDS(Queue:Browse)
    CASE KEYCODE()                                ! What keycode was hit
    OF MouseLeft2
      IF LocalRequest = SelectRecord
        POST(Event:Accepted,?Select)
        EXIT
      END
      POST(Event:Accepted,?Change)
      DO BRW1::FillBuffer
    OF InsertKey
      POST(Event:Accepted,?Insert)
    OF DeleteKey
      POST(Event:Accepted,?Delete)
    OF CtrlEnter
      POST(Event:Accepted,?Change)
    ELSE                                          ! ELSE (What keycode was hit)
      IF CHR(KEYCHAR())
        DO BRW1::ResetClear
        URL:Keyword = CHR(KEYCHAR())
        GET(URLMGR,0)
        DO BRW1::LocateRecord                     ! Find the record
      END
    END                                           ! END (What keycode was hit)
  END
  IF NOT BRW1::NewSelectPosted
    BRW1::NewSelectPosted = True
    POST(Event:NewSelection,?List)
  END
!----------------------------------------------------------------------
BRW1::ValidateRecord ROUTINE
  BRW1::RecordStatus = Record:OK
  EXIT
!----------------------------------------------------------------------
BRW1::FillForward ROUTINE
  IF BRW1::ItemsToFill > 1
    IF SEND(URLMGR,'QUICKSCAN=on').
    BRW1::QuickScan = True
  END
  LOOP WHILE BRW1::ItemsToFill
    NOMEMO(URLMGR)
    NEXT(URLMGR)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BEGIN
        GET(Queue:Browse,RECORDS(Queue:Browse))
        DO BRW1::FillBuffer
        BREAK
      END
      CYCLE
    END
    IF RECORDS(Queue:Browse) = ?List{Prop:Items}
      GET(Queue:Browse,1)
      DELETE(Queue:Browse)
    END
    BRW1::ItemsToFill -= 1
    DO BRW1::FillQueue
    ADD(Queue:Browse)
  END
  IF BRW1::QuickScan
    IF SEND(URLMGR,'QUICKSCAN=off').
    BRW1::QuickScan = False
  END
  EXIT
!----------------------------------------------------------------------
BRW1::FillBackward ROUTINE
  IF BRW1::ItemsToFill > 1
    IF SEND(URLMGR,'QUICKSCAN=on').
    BRW1::QuickScan = True
  END
  LOOP WHILE BRW1::ItemsToFill
    NOMEMO(URLMGR)
    PREVIOUS(URLMGR)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BEGIN
        GET(Queue:Browse,1)
        DO BRW1::FillBuffer
        BREAK
      END
      CYCLE
    END
    IF RECORDS(Queue:Browse) = ?List{Prop:Items}
      GET(Queue:Browse,RECORDS(Queue:Browse))
      DELETE(Queue:Browse)
    END
    BRW1::ItemsToFill -= 1
    DO BRW1::FillQueue
    ADD(Queue:Browse,1)
  END
  IF BRW1::QuickScan
    IF SEND(URLMGR,'QUICKSCAN=off').
    BRW1::QuickScan = False
  END
  EXIT
!----------------------------------------------------------------------
BRW1::LocateRecord ROUTINE
  SETCURSOR(Cursor:Wait)
  FREE(Queue:Browse)
  IF POSITION(URL:K_Keyword)
    RESET(URL:K_Keyword,POSITION(URL:K_Keyword))
  ELSE
    SET(URL:K_Keyword,URL:K_Keyword)
  END
  BRW1::LocatedPosition = ''
  LOOP
    NOMEMO(URLMGR)
    NEXT(URLMGR)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BREAK
      CYCLE
    END
    BRW1::LocatedPosition = POSITION(URL:K_Keyword)
    RESET(URL:K_Keyword,BRW1::LocatedPosition)
    BREAK
  END
  BRW1::ItemsToFill = ?List{Prop:Items}
  DO BRW1::FillForward
  IF BRW1::ItemsToFill
    IF ~RECORDS(Queue:Browse)
      DO BRW1::ResetHigh                          ! Reset for first page access
    ELSE
      GET(Queue:Browse,1)
      RESET(URL:K_Keyword,BRW1::Position)
      NOMEMO(URLMGR)
      PREVIOUS(URLMGR)
    END
    DO BRW1::FillBackward
  END
  IF ~RECORDS(Queue:Browse)
    CLEAR(URL:Record)
    CLEAR(URL:SiteInfo)
    ?List{Prop:Disable} = 1
    ?Change{Prop:Disable} = 1
    ?Delete{Prop:Disable} = 1
  ELSE
    ?List{Prop:Disable} = 0
    IF BRW1::LocatedPosition
      BRW1::QueuePointer = 1
      LOOP
        GET(Queue:Browse,BRW1::QueuePointer)
        IF ERRORCODE() THEN BREAK.
        IF BRW1::Position = BRW1::LocatedPosition THEN BREAK.
        BRW1::QueuePointer += 1
      END
    ELSE
      BRW1::QueuePointer = RECORDS(Queue:Browse)
    END
    SELECT(?List,BRW1::QueuePointer)
    DO BRW1::FillBuffer
    ?Change{Prop:Disable} = 0
    ?Delete{Prop:Disable} = 0
  END
  SETCURSOR()
  EXIT
!----------------------------------------------------------------------
BRW1::RefreshPage ROUTINE
  SETCURSOR(Cursor:Wait)
  IF NOT RECORDS(Queue:Browse)
    BRW1::InitializePage = True
    DO BRW1::ResetLow
  ELSE
    BRW1::InitializePage = False
    GET(Queue:Browse,1)
    RESET(URL:K_Keyword,BRW1::Position)
  END
  FREE(Queue:Browse)
  BRW1::ItemsToFill = ?List{Prop:Items}
  DO BRW1::FillForward
  IF NOT BRW1::InitializePage
    IF BRW1::ItemsToFill
      GET(Queue:Browse,1)
      RESET(URL:K_Keyword,BRW1::Position)
      NOMEMO(URLMGR)
      PREVIOUS(URLMGR)
      DO BRW1::FillBackward
    END
  END
  IF ~RECORDS(Queue:Browse)
    CLEAR(URL:Record)
    CLEAR(URL:SiteInfo)
    ?List{Prop:Disable} = 1
    ?Change{Prop:Disable} = 1
    ?Delete{Prop:Disable} = 1
  ELSE
    ?List{Prop:Disable} = 0
    GET(Queue:Browse,CHOICE(?List))
    IF ERRORCODE()
      GET(Queue:Browse,RECORDS(Queue:Browse))
    END
    DO BRW1::FillBuffer
    ?Change{Prop:Disable} = 0
    ?Delete{Prop:Disable} = 0
  END
  SETCURSOR()
  EXIT
!----------------------------------------------------------------
BRW1::ButtonInsert ROUTINE
  GET(URLMGR,0)
  CLEAR(URL:Record,0)
  CLEAR(URL:SiteInfo)
  SET(URL:K_Keyword)
  LocalRequest = InsertRecord
  DO BRW1::CallUpdate
  IF LocalResponse = RequestCompleted
    DO BRW1::ValidateRecord
    IF BRW1::RecordStatus = Record:OK
      DO BRW1::LocateRecord
    END
  END
  LocalRequest = OriginalRequest
  SELECT(?List)
  ForceRefresh = True
  DO RefreshWindow
!----------------------------------------------------------------
BRW1::ButtonChange ROUTINE
  LocalRequest = ChangeRecord
  DO BRW1::CallUpdate
  IF LocalResponse = RequestCompleted
    DO BRW1::ValidateRecord
    IF BRW1::RecordStatus = Record:OK
      IF BRW1::Position = POSITION(URL:K_Keyword)
        DO BRW1::RefreshPage
      ELSE
        DO BRW1::LocateRecord
      END
    ELSE
      SELECT(?List,CHOICE(?List))
    END
  END
  LocalRequest = OriginalRequest
  SELECT(?List)
  ForceRefresh = True
  DO RefreshWindow
!----------------------------------------------------------------
BRW1::ButtonDelete ROUTINE
  LocalRequest = DeleteRecord
  DO BRW1::CallUpdate
  IF LocalResponse = RequestCompleted
    DELETE(Queue:Browse)
    DO BRW1::RefreshPage
  END
  LocalRequest = OriginalRequest
  SELECT(?List)
  ForceRefresh = True
  DO RefreshWindow
!----------------------------------------------------------------
BRW1::CallUpdate ROUTINE
  GlobalRequest = LocalRequest
  Update_URL
  LocalResponse = GlobalResponse

ReportURLByKeyword PROCEDURE
RejectRecord         LONG,AUTO
LocalRequest         LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG,AUTO
RecordsToProcess     LONG,AUTO
RecordsProcessed     LONG,AUTO
RecordsPerCycle      LONG,AUTO
RecordsThisCycle     LONG,AUTO
PercentProgress      DECIMAL(4,1)
RecordStatus         BYTE,AUTO
!-----------------------------------------------------------------------------
report               REPORT,AT(1000,2000,6000,7000),PRE(RPT),FONT('Arial',10,,),THOUS
                       HEADER,AT(1000,1000,6000,1000)
                         STRING('URLMGR Record List In Keyword Order'),AT(100,,,),FONT('Arial',12,,)
                       END
detail                 DETAIL
                         STRING('Keyword = '),AT(100,0,,)
                         STRING(@s10),AT(1800,0,,),USE(URL:Keyword)
                         STRING('Location = '),AT(100,200,,)
                         STRING(@S60),AT(1800,200,,),USE(URL:Location)
                         STRING('Description = '),AT(100,400,,)
                         STRING(@S60),AT(1800,400,,),USE(URL:Description)
                         STRING('Category = '),AT(100,600,,)
                         STRING(@S15),AT(1800,600,,),USE(URL:Category)
                         STRING('Rating = '),AT(100,800,,)
                         STRING(@N2),AT(1800,800,,),USE(URL:Rating)
                       END
                       FOOTER,AT(1000,9000,6000,1000)
                       END
                     END
ProgressWindow       WINDOW('Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       BOX,AT(15,15,111,12),COLOR(00H),FILL(0FFFFFFH)
                       BOX,AT(21,18,100,6),COLOR(00H),FILL(0C0C0C0H)
                       BOX,AT(21,18,100,6),USE(?Progress:Thermometer),FILL(0FFH)
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END
  CODE
  LocalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  IF URLMGR::Used = 0
    CheckOpen(URLMGR,1)
  END
  URLMGR::Used += 1
  RecordsToProcess = RECORDS(URLMGR)
  RecordsPerCycle = 25
  RecordsProcessed = 0
  PercentProgress = 0
  OPEN(ProgressWindow)
  ?Progress:Thermometer{Prop:Width} = 0
  ?Progress:PctText{Prop:Text} = '0.0% Completed'
    ProgressWindow{Prop:Text} = 'Printing Report'
  ?Progress:UserString{Prop:Text}=''
  IF SEND(URLMGR,'QUICKSCAN=on').
  ACCEPT
    CASE EVENT()
    OF Event:OpenWindow
      SET(URL:K_Keyword)
      LOOP
        DO GetNextURLMGR
        DO ValidateRecord
        EXECUTE RecordStatus
          BEGIN
            LocalResponse = RequestCancelled
            BREAK
          END
          CYCLE
        END
        BREAK
      END
      IF LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
        CYCLE
      END
      OPEN(report)
    OF Event:Timer
      LOOP RecordsPerCycle TIMES
        PRINT(RPT:detail)
        LOOP
          DO GetNextRecord
          DO ValidateRecord
          EXECUTE RecordStatus
            BEGIN
              LocalResponse = RequestCancelled
              BREAK
            END
            CYCLE
          END
          BREAK
        END
        IF LocalResponse = RequestCancelled
          LocalResponse = RequestCompleted
          BREAK
        END
        LocalResponse = RequestCancelled
      END
      IF LocalResponse = RequestCompleted
        POST(Event:CloseWindow)
      END
    END
    CASE FIELD()
    OF ?Progress:Cancel
      CASE Event()
      OF Event:Accepted
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
  IF SEND(URLMGR,'QUICKSCAN=off').
  CLOSE(report)
  DO ProcedureReturn
ProcedureReturn ROUTINE
  URLMGR::Used -= 1
  IF URLMGR::Used = 0 THEN CLOSE(URLMGR).
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!-----------------------------------------------------------------------------
ValidateRecord       ROUTINE
  RecordStatus = Record:OutOfRange
  IF LocalResponse = RequestCancelled THEN EXIT.
  IF ERRORCODE() THEN EXIT.
  RecordStatus = Record:OK
  EXIT
GetNextURLMGR ROUTINE
  LocalResponse = RequestCancelled
  LOOP
    NEXT(URLMGR)
    IF ERRORCODE() THEN EXIT.
    RecordsProcessed += 1
    RecordsThisCycle += 1
    IF PercentProgress < 100
      PercentProgress = (RecordsProcessed / RecordsToProcess)*100
      IF PercentProgress > 100
        PercentProgress = 100
      END
      ?Progress:Thermometer{Prop:Width} = ROUND(PercentProgress,0)
      ?Progress:PctText{Prop:Text} = FORMAT(PercentProgress,@N5.1) & '% Completed'
      DISPLAY()
    END
    BREAK
  END
  LocalResponse = RequestCompleted
  EXIT

GetNextRecord ROUTINE
  DO GetNextURLMGR
  IF LocalResponse = RequestCompleted THEN EXIT.
