                     MEMBER('URLMGR.clw')         ! This is a MEMBER module
SelectCategory PROCEDURE

LocalRequest         LONG,AUTO
OriginalRequest      LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG
WindowInitialized    LONG
ForceRefresh         LONG,AUTO
RecordFiltered       LONG
CurrentSelected  LONG,AUTO
Queue:Browse         QUEUE                        ! Browsing Queue
BRW1::CAT:Category     LIKE(CAT:Category)         ! Queue Display field
BRW1::Position         STRING(255)                ! Queue POSITION information
BRW1::Mark             BYTE                       ! Queue POSITION information
                     END                          ! END (Browsing Queue)
BRW1::QuickScan      BYTE                         ! Flag for Range/Filter test
BRW1::RecordStatus   BYTE                         ! Flag for Range/Filter test
BRW1::InitializePage BYTE                         ! Flag for Range/Filter test
BRW1::ItemsToFill    LONG                         ! Controls records retrieved
BRW1::MaxItemsInList LONG                         ! Retrieved after window opened
BRW1::LocatedPosition STRING(255)                 ! POSITION of located record
BRW1::QueuePointer   LONG                         ! Queue position of located record
BRW1::NextChoice     LONG                         ! Queue position of located record
BRW1::NewSelectPosted BYTE                        ! Queue position of located record
BRW1::CurrentScroll  BYTE                         ! Queue position of scroll thumb
BRW1::CurrentScrollRecord LONG                    ! Queue position of scroll thumb
BRW1::ScrollBuildQueue QUEUE                      ! Queue position of scroll thumb
                       STRING(10)
                     END
BRW1::KeyDistribution STRING(10),DIM(100)
BRW1::ScrollSeparation REAL                       ! Queue position of scroll thumb
BRW1::CurrentScrollSeparation REAL                ! Queue position of scroll thumb
BRW1::ScrollRecordCount LONG                      ! Queue position of scroll thumb
BrowseWindow         WINDOW('Select Default Category'),AT(0,0,136,129),SYSTEM,GRAY
                       LIST,AT(5,5,125,100),MSG('Browsing Categories Records In Category Order'),USE(?List),IMM,HVSCROLL,FORMAT('80L~Category~@s15@'),FROM(Queue:Browse)
                       BUTTON('&Add'),AT(5,110,15,12),USE(?Insert)
                       BUTTON('&Edit'),AT(20,110,15,12),USE(?Change)
                       BUTTON('&Del'),AT(35,110,15,12),USE(?Delete)
                       BUTTON('&Select'),AT(50,110,40,12),USE(?Select),DEFAULT
                       BUTTON('Close'),AT(90,110,40,12),USE(?Close)
                     END
  CODE
  LocalRequest = GlobalRequest
  OriginalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  IF Categories::Used = 0
    CheckOpen(Categories,1)
  END
  Categories::Used += 1
  OPEN(BrowseWindow)
  WindowOpened=True
  SET(CAT:K_Category)
  ?List{Prop:Alrt,251} = MouseLeft2
  IF LocalRequest = SelectRecord
    ENABLE(?Select)
    ?Select{Prop:Default} = True
  ELSE
    DISABLE(?Select)
  END
  ?List{Prop:Alrt,255} = InsertKey
  ?List{Prop:Alrt,254} = DeleteKey
  ?List{Prop:Alrt,253} = CtrlEnter
  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      END
      SELECT(?List)
    OF EVENT:GainFocus
      IF NOT WindowInitialized
        WindowInitialized = True
        DO InitializeWindow
      ELSE
        ForceRefresh = True
        DO RefreshWindow
      END
    END
    CASE FIELD()
    OF ?List
      CASE EVENT()
      OF EVENT:NewSelection
        DO BRW1::NewSelection
      OF EVENT:ScrollUp
        DO BRW1::ScrollUp
      OF EVENT:ScrollDown
        DO BRW1::ScrollDown
      OF EVENT:PageUp
        DO BRW1::PageUp
      OF EVENT:PageDown
        DO BRW1::PageDown
      OF EVENT:ScrollTop
        DO BRW1::ScrollTop
      OF EVENT:ScrollBottom
        DO BRW1::ScrollBottom
      OF EVENT:AlertKey
        DO BRW1::AlertKey
      OF EVENT:ScrollDrag
        IF ?List{Prop:VScrollPos} <= 1
          POST(Event:ScrollTop,?List)
        ELSIF ?List{Prop:VScrollPos} = 100
          POST(Event:ScrollBottom,?List)
        ELSE
          BRW1::CurrentScrollRecord = (100 * ?List{Prop:VScrollPos})/100
          CAT:Category = BRW1::KeyDistribution[BRW1::CurrentScrollRecord]
          DO BRW1::LocateRecord
        END
      END
    OF ?Insert
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO BRW1::ButtonInsert
      END
    OF ?Change
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO BRW1::ButtonChange
      END
    OF ?Delete
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO BRW1::ButtonDelete
      END
    OF ?Select
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        LocalResponse = RequestCompleted
        POST(Event:CloseWindow)
      END
    OF ?Close
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
  DO ProcedureReturn
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
  Categories::Used -= 1
  IF Categories::Used = 0 THEN CLOSE(Categories).
  IF WindowOpened
    CLOSE(BrowseWindow)
  END
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!---------------------------------------------------------------------------
InitializeWindow ROUTINE
  DO BRW1::OpenWindow
  DO RefreshWindow
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
  CurrentSelected = SELECTED()
  IF NOT ForceRefresh
    IF RECORDS(Queue:Browse)
      GET(Queue:Browse,CHOICE(?List))
      DO BRW1::FillBuffer
      DO BRW1::ValidateRecord
      IF BRW1::RecordStatus <> Record:OK
        FREE(Queue:Browse)
        DO BRW1::InitializeBrowse
      END
    ELSE
      DO BRW1::InitializeBrowse
    END
  ELSE
    DO BRW1::InitializeBrowse
    DO BRW1::RefreshPage
  END
  ?List{Prop:VScrollPos} = BRW1::CurrentScroll
  DISPLAY()
  ForceRefresh = False
  IF SELECTED() <> CurrentSelected
    SELECT(CurrentSelected)
  END
!---------------------------------------------------------------------------
SyncWindow ROUTINE
  IF RECORDS(Queue:Browse)
    GET(Queue:Browse,CHOICE(?List))
    REGET(CAT:K_Category,BRW1::Position)
  END
!---------------------------------------------------------------------------
!----------------------------------------------------------------------
BRW1::OpenWindow ROUTINE
  IF LocalRequest = SelectRecord
    SET(CAT:K_Category,CAT:K_Category)
    DO BRW1::LocateRecord
  ELSE
    DO BRW1::InitializeBrowse
    SELECT(?List,1)
  END
  DO BRW1::FillBuffer
  IF NOT BRW1::NewSelectPosted
    BRW1::NewSelectPosted = True
    POST(Event:NewSelection,?List)
  END
!----------------------------------------------------------------------
BRW1::InitializeBrowse ROUTINE
  IF SEND(Categories,'QUICKSCAN=on').
  FREE(BRW1::ScrollBuildQueue)
  SETCURSOR(Cursor:Wait)
  DO BRW1::ResetLow
  LOOP
    NEXT(Categories)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BREAK
      CYCLE
    END
    BRW1::ScrollBuildQueue = CAT:Category
    ADD(BRW1::ScrollBuildQueue)
    DO BRW1::FillQueue
  END
  SETCURSOR()
  BRW1::ScrollSeparation = RECORDS(BRW1::ScrollBuildQueue) / 100
  LOOP BRW1::CurrentScrollRecord = 2 TO 100
    IF RECORDS(BRW1::ScrollBuildQueue) > 100
      BRW1::QueuePointer = BRW1::CurrentScrollRecord * BRW1::ScrollSeparation
      GET(BRW1::ScrollBuildQueue,BRW1::QueuePointer)
      BRW1::KeyDistribution[BRW1::CurrentScrollRecord-1] = BRW1::ScrollBuildQueue
    ELSE
      GET(BRW1::ScrollBuildQueue,BRW1::CurrentScrollRecord)
      IF ERRORCODE()
        BRW1::KeyDistribution[BRW1::CurrentScrollRecord-1] = ' {10}'
      ELSE
        BRW1::KeyDistribution[BRW1::CurrentScrollRecord-1] = BRW1::ScrollBuildQueue
      END
    END
  END
  FREE(BRW1::ScrollBuildQueue)
  IF SEND(Categories,'QUICKSCAN=off').
  DO BRW1::RefreshPage
!----------------------------------------------------------------------
BRW1::FillBuffer ROUTINE
  CAT:Category = BRW1::CAT:Category
!----------------------------------------------------------------------
BRW1::ResetLow ROUTINE
  SET(CAT:K_Category)
!----------------------------------------------------------------------
BRW1::ResetHigh ROUTINE
  SET(CAT:K_Category)
!----------------------------------------------------------------------
BRW1::ResetClear ROUTINE
  SET(CAT:K_Category)
!----------------------------------------------------------------------
BRW1::FillQueue ROUTINE
  BRW1::CAT:Category = CAT:Category
  BRW1::Position = POSITION(CAT:K_Category)
!----------------------------------------------------------------------
BRW1::NewSelection ROUTINE
  BRW1::NewSelectPosted = False
  IF RECORDS(Queue:Browse)
    DO BRW1::FillBuffer
    BRW1::CurrentScroll = 100
    LOOP BRW1::CurrentScrollRecord = 1 TO 100
      IF UPPER(BRW1::KeyDistribution[BRW1::CurrentScrollRecord]) => UPPER(CAT:Category)
        IF BRW1::CurrentScrollRecord <= 1
          BRW1::CurrentScroll = 0
        ELSIF BRW1::CurrentScrollRecord = 100
          BRW1::CurrentScroll = 100
        ELSE
          BRW1::CurrentScroll = ((BRW1::CurrentScrollRecord / 100) * 100)
        END
        BREAK
      END
    END
    DO RefreshWindow
  END
!----------------------------------------------------------------------
BRW1::ScrollUp ROUTINE
  IF RECORDS(Queue:Browse)
    IF CHOICE(?List)>1
      SELECT(?List, CHOICE(?List)-1)
    ELSE
      GET(Queue:Browse,1)                         ! Get the first queue item
      RESET(CAT:K_Category,BRW1::Position)        ! Reset for sequential processing
      PREVIOUS(Categories)                        ! Retrieve record, reverse access
      BRW1::ItemsToFill = 1                       ! Load a single item
      DO BRW1::FillBackward                       ! Fill with previous read(s)
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::ScrollDown ROUTINE
  IF RECORDS(Queue:Browse)
    IF CHOICE(?List)<RECORDS(Queue:Browse)
      SELECT(?List, CHOICE(?List)+1)
    ELSE
      GET(Queue:Browse,RECORDS(Queue:Browse))     ! Get the last queue item
      RESET(CAT:K_Category,BRW1::Position)        ! Reset for sequential processing
      NEXT(Categories)                            ! Retrieve record, forward access
      BRW1::ItemsToFill = 1                       ! load a single item
      DO BRW1::FillForward                        ! Fill with next read(s)
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::PageUp ROUTINE
  IF RECORDS(Queue:Browse)
    GET(Queue:Browse,1)                           ! Get the first queue item
    RESET(CAT:K_Category,BRW1::Position)          ! Reset for sequential processing
    PREVIOUS(Categories)                          ! Retrieve record, reverse access
    BRW1::ItemsToFill = ?List{Prop:Items}         ! Load a full page
    DO BRW1::FillBackward                         ! Fill with previous read(s)
    IF BRW1::ItemsToFill
      BRW1::NextChoice = CHOICE(?List)-BRW1::ItemsToFill
      IF BRW1::NextChoice < 1
        BRW1::NextChoice = 1
      END
      SELECT(?List, BRW1::NextChoice)
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::PageDown ROUTINE
  IF RECORDS(Queue:Browse)
    GET(Queue:Browse,RECORDS(Queue:Browse))       ! Get the last queue item
    RESET(CAT:K_Category,BRW1::Position)          ! Reset for sequential processing
    NEXT(Categories)                              ! Retrieve record, forward access
    BRW1::ItemsToFill = ?List{Prop:Items}         ! Load a full page
    DO BRW1::FillForward                          ! Fill with next read(s)
    IF BRW1::ItemsToFill
      BRW1::NextChoice = CHOICE(?List)+BRW1::ItemsToFill
      IF BRW1::NextChoice > RECORDS(Queue:Browse)
        BRW1::NextChoice = RECORDS(Queue:Browse)
      END
      SELECT(?List, BRW1::NextChoice)
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::ScrollTop ROUTINE
  IF RECORDS(Queue:Browse)
    FREE(Queue:Browse)
    DO BRW1::RefreshPage
    SELECT(?List,1)                               ! Select first list item
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::ScrollBottom ROUTINE
  IF RECORDS(Queue:Browse)
    SETCURSOR(Cursor:Wait)
    FREE(Queue:Browse)                            ! Free the browse queue
    DO BRW1::ResetHigh                            ! Reset for first page access
    BRW1::ItemsToFill = ?List{Prop:Items}         ! Load a full page
    DO BRW1::FillBackward                         ! Fill with previous read(s)
    SELECT(?List, RECORDS(Queue:Browse))          ! Select last list item
    SETCURSOR()
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END
!----------------------------------------------------------------------
BRW1::AlertKey ROUTINE
  IF RECORDS(Queue:Browse)
    CASE KEYCODE()                                ! What keycode was hit
    OF MouseLeft2
      IF LocalRequest = SelectRecord
        POST(Event:Accepted,?Select)
        EXIT
      END
      POST(Event:Accepted,?Change)
      DO BRW1::FillBuffer
    OF InsertKey
      POST(Event:Accepted,?Insert)
    OF DeleteKey
      POST(Event:Accepted,?Delete)
    OF CtrlEnter
      POST(Event:Accepted,?Change)
    ELSE                                          ! ELSE (What keycode was hit)
      IF CHR(KEYCHAR())
        DO BRW1::ResetClear
        CAT:Category = CHR(KEYCHAR())
        GET(Categories,0)
        DO BRW1::LocateRecord                     ! Find the record
      END
    END                                           ! END (What keycode was hit)
  END
  IF NOT BRW1::NewSelectPosted
    BRW1::NewSelectPosted = True
    POST(Event:NewSelection,?List)
  END
!----------------------------------------------------------------------
BRW1::ValidateRecord ROUTINE
  BRW1::RecordStatus = Record:OK
  EXIT
!----------------------------------------------------------------------
BRW1::FillForward ROUTINE
  IF BRW1::ItemsToFill > 1
    IF SEND(Categories,'QUICKSCAN=on').
    BRW1::QuickScan = True
  END
  LOOP WHILE BRW1::ItemsToFill
    NEXT(Categories)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BEGIN
        GET(Queue:Browse,RECORDS(Queue:Browse))
        DO BRW1::FillBuffer
        BREAK
      END
      CYCLE
    END
    IF RECORDS(Queue:Browse) = ?List{Prop:Items}
      GET(Queue:Browse,1)
      DELETE(Queue:Browse)
    END
    BRW1::ItemsToFill -= 1
    DO BRW1::FillQueue
    ADD(Queue:Browse)
  END
  IF BRW1::QuickScan
    IF SEND(Categories,'QUICKSCAN=off').
    BRW1::QuickScan = False
  END
  EXIT
!----------------------------------------------------------------------
BRW1::FillBackward ROUTINE
  IF BRW1::ItemsToFill > 1
    IF SEND(Categories,'QUICKSCAN=on').
    BRW1::QuickScan = True
  END
  LOOP WHILE BRW1::ItemsToFill
    PREVIOUS(Categories)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BEGIN
        GET(Queue:Browse,1)
        DO BRW1::FillBuffer
        BREAK
      END
      CYCLE
    END
    IF RECORDS(Queue:Browse) = ?List{Prop:Items}
      GET(Queue:Browse,RECORDS(Queue:Browse))
      DELETE(Queue:Browse)
    END
    BRW1::ItemsToFill -= 1
    DO BRW1::FillQueue
    ADD(Queue:Browse,1)
  END
  IF BRW1::QuickScan
    IF SEND(Categories,'QUICKSCAN=off').
    BRW1::QuickScan = False
  END
  EXIT
!----------------------------------------------------------------------
BRW1::LocateRecord ROUTINE
  SETCURSOR(Cursor:Wait)
  FREE(Queue:Browse)
  IF POSITION(CAT:K_Category)
    RESET(CAT:K_Category,POSITION(CAT:K_Category))
  ELSE
    SET(CAT:K_Category,CAT:K_Category)
  END
  BRW1::LocatedPosition = ''
  LOOP
    NEXT(Categories)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BREAK
      CYCLE
    END
    BRW1::LocatedPosition = POSITION(CAT:K_Category)
    RESET(CAT:K_Category,BRW1::LocatedPosition)
    BREAK
  END
  BRW1::ItemsToFill = ?List{Prop:Items}
  DO BRW1::FillForward
  IF BRW1::ItemsToFill
    IF ~RECORDS(Queue:Browse)
      DO BRW1::ResetHigh                          ! Reset for first page access
    ELSE
      GET(Queue:Browse,1)
      RESET(CAT:K_Category,BRW1::Position)
      PREVIOUS(Categories)
    END
    DO BRW1::FillBackward
  END
  IF ~RECORDS(Queue:Browse)
    CLEAR(CAT:Record)
    ?List{Prop:Disable} = 1
    ?Change{Prop:Disable} = 1
    ?Delete{Prop:Disable} = 1
  ELSE
    ?List{Prop:Disable} = 0
    IF BRW1::LocatedPosition
      BRW1::QueuePointer = 1
      LOOP
        GET(Queue:Browse,BRW1::QueuePointer)
        IF ERRORCODE() THEN BREAK.
        IF BRW1::Position = BRW1::LocatedPosition THEN BREAK.
        BRW1::QueuePointer += 1
      END
    ELSE
      BRW1::QueuePointer = RECORDS(Queue:Browse)
    END
    SELECT(?List,BRW1::QueuePointer)
    DO BRW1::FillBuffer
    ?Change{Prop:Disable} = 0
    ?Delete{Prop:Disable} = 0
  END
  SETCURSOR()
  EXIT
!----------------------------------------------------------------------
BRW1::RefreshPage ROUTINE
  SETCURSOR(Cursor:Wait)
  IF NOT RECORDS(Queue:Browse)
    BRW1::InitializePage = True
    DO BRW1::ResetLow
  ELSE
    BRW1::InitializePage = False
    GET(Queue:Browse,1)
    RESET(CAT:K_Category,BRW1::Position)
  END
  FREE(Queue:Browse)
  BRW1::ItemsToFill = ?List{Prop:Items}
  DO BRW1::FillForward
  IF NOT BRW1::InitializePage
    IF BRW1::ItemsToFill
      GET(Queue:Browse,1)
      RESET(CAT:K_Category,BRW1::Position)
      PREVIOUS(Categories)
      DO BRW1::FillBackward
    END
  END
  IF ~RECORDS(Queue:Browse)
    CLEAR(CAT:Record)
    ?List{Prop:Disable} = 1
    ?Change{Prop:Disable} = 1
    ?Delete{Prop:Disable} = 1
  ELSE
    ?List{Prop:Disable} = 0
    GET(Queue:Browse,CHOICE(?List))
    IF ERRORCODE()
      GET(Queue:Browse,RECORDS(Queue:Browse))
    END
    DO BRW1::FillBuffer
    ?Change{Prop:Disable} = 0
    ?Delete{Prop:Disable} = 0
  END
  SETCURSOR()
  EXIT
!----------------------------------------------------------------
BRW1::ButtonInsert ROUTINE
  GET(Categories,0)
  CLEAR(CAT:Record,0)
  SET(CAT:K_Category)
  LocalRequest = InsertRecord
  DO BRW1::CallUpdate
  IF LocalResponse = RequestCompleted
    DO BRW1::ValidateRecord
    IF BRW1::RecordStatus = Record:OK
      DO BRW1::LocateRecord
    END
  END
  LocalRequest = OriginalRequest
  SELECT(?List)
  ForceRefresh = True
  DO RefreshWindow
!----------------------------------------------------------------
BRW1::ButtonChange ROUTINE
  LocalRequest = ChangeRecord
  DO BRW1::CallUpdate
  IF LocalResponse = RequestCompleted
    DO BRW1::ValidateRecord
    IF BRW1::RecordStatus = Record:OK
      IF BRW1::Position = POSITION(CAT:K_Category)
        DO BRW1::RefreshPage
      ELSE
        DO BRW1::LocateRecord
      END
    ELSE
      SELECT(?List,CHOICE(?List))
    END
  END
  LocalRequest = OriginalRequest
  SELECT(?List)
  ForceRefresh = True
  DO RefreshWindow
!----------------------------------------------------------------
BRW1::ButtonDelete ROUTINE
  LocalRequest = DeleteRecord
  DO BRW1::CallUpdate
  IF LocalResponse = RequestCompleted
    DELETE(Queue:Browse)
    DO BRW1::RefreshPage
  END
  LocalRequest = OriginalRequest
  SELECT(?List)
  ForceRefresh = True
  DO RefreshWindow
!----------------------------------------------------------------
BRW1::CallUpdate ROUTINE
  GlobalRequest = LocalRequest
  Update_CAT
  LocalResponse = GlobalResponse

