                     MEMBER('URLMGR.clw')


!--------------------------------------------------
RIUpdate:ASCIIfile   FUNCTION(Passed:Buffer)
Process:Buffer       LIKE(ASC:Record),PRE(RP),OVER(Passed:Buffer)
Current:Buffer       LIKE(ASC:Record),PRE(RC)
Current:Position     STRING(512)
  CODE
  Current:Position = POSITION(ASCIIfile)
  Current:Buffer = ASC:Record
  REGET(ASCIIfile,Current:Position)
  IF ERRORCODE()
    IF StandardWarning(Warn:RIUpdateError,'Record Changed/Deleted by Another Station')
      ROLLBACK()
      DO RICloseFiles
      RETURN(1)
    END
  END
  IF ASC:Record <> Passed:Buffer
    IF StandardWarning(Warn:RIUpdateError,'Record Changed by Another Station')
      ROLLBACK()
      REGET(ASCIIfile,Current:Position)
      DO RICloseFiles
      RETURN(1)
    END
  END
  ASC:Record = Current:Buffer
  PUT(ASCIIfile)
  IF ERRORCODE()
    IF StandardWarning(Warn:RIUpdateError,'ASCIIfile')
      ROLLBACK
      DO RICloseFiles
      RETURN(1)
    END
  ELSE
    COMMIT
    DO RICloseFiles
    RETURN(0)
  END
!----------------------------------------------------------------------
RICloseFiles ROUTINE
  EXIT

!--------------------------------------------------
RIUpdate:Categories  FUNCTION(Passed:Buffer)
Process:Buffer       LIKE(CAT:Record),PRE(RP),OVER(Passed:Buffer)
Current:Buffer       LIKE(CAT:Record),PRE(RC)
Current:Position     STRING(512)
  CODE
  Current:Position = POSITION(CAT:K_Category)
  Current:Buffer = CAT:Record
      IF URLMGR::Used = 0
        CheckOpen(URLMGR,1)
      END
      URLMGR::Used += 1
  LOGOUT(2,Categories,URLMGR)
  REGET(CAT:K_Category,Current:Position)
  IF ERRORCODE()
    IF StandardWarning(Warn:RIUpdateError,'Record Changed/Deleted by Another Station')
      ROLLBACK()
      DO RICloseFiles
      RETURN(1)
    END
  END
  IF CAT:Record <> Passed:Buffer
    IF StandardWarning(Warn:RIUpdateError,'Record Changed by Another Station')
      ROLLBACK()
      REGET(CAT:K_Category,Current:Position)
      DO RICloseFiles
      RETURN(1)
    END
  END
  CAT:Record = Current:Buffer
  IF RP:Category <> RC:Category
    IF RIUpdate:Categories:URLMGR(RP:Category)
      ROLLBACK
      DO RICloseFiles
      RETURN(1)
    END
  END
  PUT(Categories)
  IF ERRORCODE()
    IF StandardWarning(Warn:RIUpdateError,'Categories')
      ROLLBACK
      DO RICloseFiles
      RETURN(1)
    END
  ELSE
    COMMIT
    DO RICloseFiles
    RETURN(0)
  END
!----------------------------------------------------------------------
RICloseFiles ROUTINE
  URLMGR::Used -= 1
  IF URLMGR::Used = 0 THEN CLOSE(URLMGR).
  EXIT

!--------------------------------------------------
RIUpdate:URLMGR      FUNCTION(Passed:Buffer,Passed:URL:SiteInfo)
Process:Buffer       LIKE(URL:Record),PRE(RP),OVER(Passed:Buffer)
Current:Buffer       LIKE(URL:Record),PRE(RC)
Current:Position     STRING(512)
Current:URL:SiteInfo LIKE(URL:SiteInfo)
  CODE
  Current:Position = POSITION(URL:K_Location)
  Current:Buffer = URL:Record
  Current:URL:SiteInfo = URL:SiteInfo
  LOGOUT(2,URLMGR)
  REGET(URL:K_Location,Current:Position)
  IF ERRORCODE()
    IF StandardWarning(Warn:RIUpdateError,'Record Changed/Deleted by Another Station')
      ROLLBACK()
      DO RICloseFiles
      RETURN(1)
    END
  END
  IF URL:Record <> Passed:Buffer |
  OR URL:SiteInfo <> Passed:URL:SiteInfo
    IF StandardWarning(Warn:RIUpdateError,'Record Changed by Another Station')
      ROLLBACK()
      REGET(URL:K_Location,Current:Position)
      DO RICloseFiles
      RETURN(1)
    END
  END
  URL:Record = Current:Buffer
  URL:SiteInfo = Current:URL:SiteInfo
  PUT(URLMGR)
  IF ERRORCODE()
    IF StandardWarning(Warn:RIUpdateError,'URLMGR')
      ROLLBACK
      DO RICloseFiles
      RETURN(1)
    END
  ELSE
    COMMIT
    DO RICloseFiles
    RETURN(0)
  END
!----------------------------------------------------------------------
RICloseFiles ROUTINE
  EXIT
!--------------------------------------------------
RIUpdate:Categories:URLMGR FUNCTION(RP:CAT:Category)

    CODE
    CLEAR(URL:Record,0)
    URL:Category = RP:CAT:Category
    SET(URL:K_Category,URL:K_Category)
    LOOP
      NEXT(URLMGR)
      IF ERRORCODE() THEN RETURN(0).
      IF URL:Category <> RP:CAT:Category
        RETURN(0)
      END
      URL:Category = CAT:Category
      PUT(URLMGR)
      IF ERRORCODE()
        IF StandardWarning(Warn:RIUpdateError,'URLMGR')
          RETURN(1)
        END
      END
    END
